<a id="use-internal-service"></id>

### 使用预置服务

Vert 预置了一些常用的服务，这些服务在 `@vert/services` 中：

> 详细信息请查看 @vert/services 模块文档.
 
```typescript
import { Http } from '@vert/services'
import { Inject, Injectable } from '@vert/core'

// 您的业务服务：TreasureBox.
// 使用内置服务 Http 作为数据请求发起方法.
@Injectable
class TreasureBox {
  async fetchData () {
    const { data } = await this.http.get('/api/v1/treasure-box')
    return data
  }
  
  constructor (public http: Http) {}
}

export {
  TreasureBox
}
```

您创建了一个名为 `TreasureBox` 的 class，其中提供了数据请求方法 `fetchData`，并且您将内部服务 `Http` 注入至类中作为请求发起方法使用.

> 关于服务依赖注入的更多内容，请参考章节 [编写可注入的 Class](#di-for-class).
